PROJECT_NAME := experimental_ble_app_hrs_advertiser_s130_pca10028_timeslot

export OUTPUT_FILENAME
#MAKEFILE_NAME := $(CURDIR)/$(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
MAKEFILE_NAME := $(MAKEFILE_LIST)
MAKEFILE_DIR := $(dir $(MAKEFILE_NAME) ) 

TEMPLATE_PATH = C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/toolchain/gcc
ifeq ($(OS),Windows_NT)
include $(TEMPLATE_PATH)/Makefile.windows
else
include $(TEMPLATE_PATH)/Makefile.posix
endif

MK := mkdir
RM := rm -rf

#echo suspend
ifeq ("$(VERBOSE)","1")
NO_ECHO := 
else
NO_ECHO := @
endif

# Toolchain commands
CC              := '$(GNU_INSTALL_ROOT)/bin/$(GNU_PREFIX)-gcc'
AS              := '$(GNU_INSTALL_ROOT)/bin/$(GNU_PREFIX)-as'
AR              := '$(GNU_INSTALL_ROOT)/bin/$(GNU_PREFIX)-ar' -r
LD              := '$(GNU_INSTALL_ROOT)/bin/$(GNU_PREFIX)-ld'
NM              := '$(GNU_INSTALL_ROOT)/bin/$(GNU_PREFIX)-nm'
OBJDUMP         := '$(GNU_INSTALL_ROOT)/bin/$(GNU_PREFIX)-objdump'
OBJCOPY         := '$(GNU_INSTALL_ROOT)/bin/$(GNU_PREFIX)-objcopy'
SIZE            := '$(GNU_INSTALL_ROOT)/bin/$(GNU_PREFIX)-size'

#function for removing duplicates in a list
remduplicates = $(strip $(if $1,$(firstword $1) $(call remduplicates,$(filter-out $(firstword $1),$1))))

#source common to all targets
C_SOURCE_FILES += \
$(abspath ./main.c) \
$(abspath ./advertiser_ibeacon.c) \
$(abspath ./ble_egs.c) \
$(abspath ./config/MMA8452Q.c) \
$(abspath ./config/bsp.c) \
$(abspath ./config/bsp_btn_ble.c) \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/ble_services/ble_bas/ble_bas.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/common/ble_srv_common.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/ble_services/ble_dis/ble_dis.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/common/ble_conn_params.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/ble_advertising/ble_advertising.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/common/ble_advdata.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/gatt_cache_manager.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/gattc_cache_manager.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/gatts_cache_manager.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/id_manager.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/peer_data.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/peer_data_storage.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/peer_database.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/peer_id.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/peer_manager.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/pm_buffer.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/pm_mutex.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/security_dispatcher.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/security_manager.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager/security_dispatcher.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/common/ble_conn_state.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/gpiote/nrf_drv_gpiote.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/common/nrf_drv_common.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/pstorage/pstorage.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/delay/nrf_delay.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/twi_master/nrf_drv_twi.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/util/app_error.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/sensorsim/sensorsim.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/timer/app_timer.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/button/app_button.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/fds/fds.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/fstorage/fstorage.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/util/sdk_mapped_flags.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/twi/app_twi.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/softdevice/common/softdevice_handler/softdevice_handler.c \
C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/toolchain/system_nrf51.c \

#assembly files common to all targets
ASM_SOURCE_FILES  = C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/toolchain/gcc/gcc_startup_nrf51.s

#includes common to all targets
INC_PATHS  = -I$(abspath ./config)
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/common
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/softdevice/common/softdevice_handler
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/softdevice/s130/headers
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/hal
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/common
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/fifo
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/trace
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/device
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/config
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/util
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/ble_services/ble_bas
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/pstorage
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/peer_manager
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/fds
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/fstorage
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/experimental_section_vars
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/softdevice/s130/headers
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/ble_services/ble_dis
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/toolchain/gcc
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/delay
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/device_manager
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/gpiote
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/timer
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/button
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/ble/ble_advertising
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/sensorsim
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/drivers_nrf/twi_master
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/libraries/twi
INC_PATHS += -IC:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/toolchain

OBJECT_DIRECTORY = _build
LISTING_DIRECTORY = $(OBJECT_DIRECTORY)
OUTPUT_BINARY_DIRECTORY = $(OBJECT_DIRECTORY)

# Sorting removes duplicates
BUILD_DIRECTORIES := $(sort $(OBJECT_DIRECTORY) $(OUTPUT_BINARY_DIRECTORY) $(LISTING_DIRECTORY) )

#flags common to all targets
CFLAGS  = -DBOARD_PCA10028
CFLAGS += -DSWI_DISABLE0
CFLAGS += -DSOFTDEVICE_PRESENT
CFLAGS += -DNRF51
CFLAGS += -DS130
CFLAGS += -DBLE_STACK_SUPPORT_REQD
CFLAGS += -mcpu=cortex-m0
CFLAGS += -mthumb -mabi=aapcs --std=gnu99
CFLAGS += -Wall -O3
CFLAGS += -mfloat-abi=soft
# keep every function in separate section. This will allow linker to dump unused functions
CFLAGS += -ffunction-sections -fdata-sections -fno-strict-aliasing
CFLAGS += -fno-builtin --short-enums

# keep every function in separate section. This will allow linker to dump unused functions
LDFLAGS += -Xlinker -Map=$(LISTING_DIRECTORY)/$(OUTPUT_FILENAME).map
LDFLAGS += -mthumb -mabi=aapcs -L $(TEMPLATE_PATH) -T$(LINKER_SCRIPT)
LDFLAGS += -mcpu=cortex-m0
# let linker to dump unused sections
LDFLAGS += -Wl,--gc-sections
# use newlib in nano version
LDFLAGS += --specs=nano.specs -lc -lnosys

# Assembler flags
ASMFLAGS += -x assembler-with-cpp
ASMFLAGS += -DBOARD_PCA10028
ASMFLAGS += -DSWI_DISABLE0
ASMFLAGS += -DSOFTDEVICE_PRESENT
ASMFLAGS += -DNRF51
ASMFLAGS += -DS130
ASMFLAGS += -DBLE_STACK_SUPPORT_REQD
#default target - first one defined
default: clean nrf51422_xxac

#building all targets
all: clean
	$(NO_ECHO)$(MAKE) -f $(MAKEFILE_NAME) -C $(MAKEFILE_DIR) -e cleanobj
	$(NO_ECHO)$(MAKE) -f $(MAKEFILE_NAME) -C $(MAKEFILE_DIR) -e nrf51422_xxac

#target for printing all targets
help:
	@echo following targets are available:
	@echo 	nrf51422_xxac
	@echo 	flash_softdevice


C_SOURCE_FILE_NAMES = $(notdir $(C_SOURCE_FILES))
C_PATHS = $(call remduplicates, $(dir $(C_SOURCE_FILES) ) )
C_OBJECTS = $(addprefix $(OBJECT_DIRECTORY)/, $(C_SOURCE_FILE_NAMES:.c=.o) )

ASM_SOURCE_FILE_NAMES = $(notdir $(ASM_SOURCE_FILES))
ASM_PATHS = $(call remduplicates, $(dir $(ASM_SOURCE_FILES) ))
ASM_OBJECTS = $(addprefix $(OBJECT_DIRECTORY)/, $(ASM_SOURCE_FILE_NAMES:.s=.o) )

vpath %.c $(C_PATHS)
vpath %.s $(ASM_PATHS)

OBJECTS = $(C_OBJECTS) $(ASM_OBJECTS)

nrf51422_xxac: OUTPUT_FILENAME := nrf51422_xxac
nrf51422_xxac: LINKER_SCRIPT=ellcie-healthy.ld
nrf51422_xxac: $(BUILD_DIRECTORIES) $(OBJECTS)
	@echo Linking target: $(OUTPUT_FILENAME).out
	$(NO_ECHO)$(CC) $(LDFLAGS) $(OBJECTS) $(LIBS) -o $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).out
	$(NO_ECHO)$(MAKE) -f $(MAKEFILE_NAME) -C $(MAKEFILE_DIR) -e finalize

## Create build directories
$(BUILD_DIRECTORIES):
	echo $(MAKEFILE_NAME)
	$(MK) $@

# Create objects from C SRC files
$(OBJECT_DIRECTORY)/%.o: %.c
	@echo Compiling file: $(notdir $<)
	$(NO_ECHO)$(CC) $(CFLAGS) $(INC_PATHS) -c -o $@ $<

# Assemble files
$(OBJECT_DIRECTORY)/%.o: %.s
	@echo Compiling file: $(notdir $<)
	$(NO_ECHO)$(CC) $(ASMFLAGS) $(INC_PATHS) -c -o $@ $<


# Link
$(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).out: $(BUILD_DIRECTORIES) $(OBJECTS)
	@echo Linking target: $(OUTPUT_FILENAME).out
	$(NO_ECHO)$(CC) $(LDFLAGS) $(OBJECTS) $(LIBS) -o $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).out


## Create binary .bin file from the .out file
$(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).bin: $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).out
	@echo Preparing: $(OUTPUT_FILENAME).bin
	$(NO_ECHO)$(OBJCOPY) -O binary $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).out $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).bin

## Create binary .hex file from the .out file
$(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).hex: $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).out
	@echo Preparing: $(OUTPUT_FILENAME).hex
	$(NO_ECHO)$(OBJCOPY) -O ihex $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).out $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).hex

finalize: genbin genhex echosize

genbin:
	@echo Preparing: $(OUTPUT_FILENAME).bin
	$(NO_ECHO)$(OBJCOPY) -O binary $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).out $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).bin

## Create binary .hex file from the .out file
genhex: 
	@echo Preparing: $(OUTPUT_FILENAME).hex
	$(NO_ECHO)$(OBJCOPY) -O ihex $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).out $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).hex

echosize:
	-@echo ''
	$(NO_ECHO)$(SIZE) $(OUTPUT_BINARY_DIRECTORY)/$(OUTPUT_FILENAME).out
	-@echo ''

clean:
	$(RM) $(BUILD_DIRECTORIES)

cleanobj:
	$(RM) $(BUILD_DIRECTORIES)/*.o

flash: $(MAKECMDGOALS)
	@echo Flashing: $(OUTPUT_BINARY_DIRECTORY)/$<.hex
	nrfjprog --program $(OUTPUT_BINARY_DIRECTORY)/$<.hex -f nrf51  --sectorerase
	nrfjprog --reset

## Flash softdevice
flash_softdevice:
	@echo Flashing: s130_nrf51_1.0.0_softdevice.hex
	nrfjprog --program C:/Users/Mathieu/Documents/Nordic/Nordic_SDK_V10.0.0/components/softdevice/s130/hex/s130_nrf51_1.0.0_softdevice.hex -f nrf51 --chiperase
	nrfjprog --reset